
--      flatten.lua
--      
--      Copyright 2012 Michael Kosler <marekkpie@gmail.com>
--      
--      This program is free software; you can redistribute it and/or modify
--      it under the terms of the GNU General Public License as published by
--      the Free Software Foundation; either version 2 of the License, or
--      (at your option) any later version.
--      
--      This program is distributed in the hope that it will be useful,
--      but WITHOUT ANY WARRANTY; without even the implied warranty of
--      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--      GNU General Public License for more details.
--      
--      You should have received a copy of the GNU General Public License
--      along with this program; if not, write to the Free Software
--      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
--      MA 02110-1301, USA.
--      
--      


local function findNeighbors(wallMap, row, col)
	local skipList = {}
	local rmin = -1
	local rmax = 1
	local cmin = -1
	local cmax = 1
	if row == 1 then
		rmin = 0
	elseif row == #wallMap then
		rmax = 0
	end
	if col == 1 then
		cmin = 0
	elseif col == #wallMap[row] then
		cmax = 0
	end
	local neighbors = {}
	local distance = {}
	for i = rmin, rmax do
		for j = cmin, cmax do
			if 	not wallMap[row + i][col + j].wall and
				not (i == 0 and j == 0) then
				local len = math.abs(i) + math.abs(j)
				if len == 2 then
					table.insert(distance, 14)
				elseif len == 1 then
					table.insert(distance, 10)
				end
				table.insert(neighbors, (((row - 1) + i) * #wallMap) + (col + j))
			end
		end
	end
	return neighbors, distance
end

function debugPathMap(map)
	local index = 1
	for k,v in pairs(map) do
		index = index + 1
	end
end

function flattenMap(wallMap, pathMap, exitPos, method, f)
	flattenStart = love.timer.getTime()
	if method == "new" then
		flags = {}
		for row = 1, #wallMap do
			for col = 1, #wallMap[row] do
				if not wallMap[row][col].wall then
					local tempNode = {}
					tempNode.row = row
					tempNode.col = col
					tempNode.pathLoc = ((row - 1) * #wallMap) + col
					tempNode.hScore = (math.abs(row - exitPos.r) + math.abs(col - exitPos.c)) * 10
					tempNode.neighbors, tempNode.distance = findNeighbors(wallMap, row, col)
					pathMap[((row - 1) * #wallMap) + col] = tempNode
				end
			end
		end
	end
	flattenEnd = love.timer.getTime()
	return pathMap
end
